Gecode::Int::Bool::IteBase< V0, V1, V2, pc > Class Template Reference
Other available functionality » Integer propagators

If-then-else propagator base-class. More...

`#include <bool.hh>`

## Public Member Functions

virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low ternary).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Member Functions

| IteBase (Space &home, IteBase &p)
| Constructor for cloning p.
| IteBase (Home home, BoolView b, V0 x0, V1 x1, V2 x2)
| Constructor for creation.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

BoolView | b
| View for condition.
V0 | x0
| Views.
V1 | x1
V2 | x2

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Detailed Description

template<class V0, class V1, class V2, PropCond pc>
class Gecode::Int::Bool::IteBase< V0, V1, V2, pc >

If-then-else propagator base-class.

Requires

#include <gecode/int/bool.hh>
bool.hh

Definition at line 580 of file bool.hh.

## Constructor & Destructor Documentation

## IteBase() [1/2]

template<class V0, class V1, class V2, PropCond pc>

Gecode::Int::Bool::IteBase< V0, V1, V2, pc >::IteBase | ( | Space & | home,
|  | IteBase< V0, V1, V2, pc > & | p )

inline protected

Constructor for cloning p.

Definition at line 52 of file ite.hpp.

## IteBase() [2/2]

template<class V0, class V1, class V2, PropCond pc>

Gecode::Int::Bool::IteBase< V0, V1, V2, pc >::IteBase | ( | Home | home,
|  | BoolView | b,
|  | V0 | x0,
|  | V1 | x1,
|  | V2 | x2 )

inline protected

Constructor for creation.

Definition at line 42 of file ite.hpp.

## Member Function Documentation

## cost()

template<class V0, class V1, class V2, PropCond pc>

PropCost Gecode::Int::Bool::IteBase< V0, V1, V2, pc >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low ternary).

Implements Gecode::Propagator.

Reimplemented in Gecode::Int::Bool::IteDom< V0, V1, V2 >.

Definition at line 62 of file ite.hpp.

## reschedule()

template<class V0, class V1, class V2, PropCond pc>

void Gecode::Int::Bool::IteBase< V0, V1, V2, pc >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 68 of file ite.hpp.

## dispose()

template<class V0, class V1, class V2, PropCond pc>

size_t Gecode::Int::Bool::IteBase< V0, V1, V2, pc >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 77 of file ite.hpp.

## Member Data Documentation

## b

template<class V0, class V1, class V2, PropCond pc>

BoolView Gecode::Int::Bool::IteBase< V0, V1, V2, pc >::b

protected

View for condition.

Definition at line 583 of file bool.hh.

## x0

template<class V0, class V1, class V2, PropCond pc>

V0 Gecode::Int::Bool::IteBase< V0, V1, V2, pc >::x0

protected

Views.

Definition at line 585 of file bool.hh.

## x1

template<class V0, class V1, class V2, PropCond pc>

V1 Gecode::Int::Bool::IteBase< V0, V1, V2, pc >::x1

protected

Definition at line 585 of file bool.hh.

## x2

template<class V0, class V1, class V2, PropCond pc>

V2 Gecode::Int::Bool::IteBase< V0, V1, V2, pc >::x2

protected

Definition at line 585 of file bool.hh.

The documentation for this class was generated from the following files:

- gecode/int/bool.hh
- gecode/int/bool/ite.hpp